﻿Imports System.Runtime.CompilerServices

Namespace System.Windows.Forms

	Public Module ControlX

#Region "Textbox"
		<Extension>
		Public Sub RegisterDateInput(tb As TextBox)
			AddHandler tb.Enter, AddressOf tb_Enter
			AddHandler tb.KeyDown, AddressOf tb_KeyDown
			AddHandler tb.Leave, AddressOf tb_Leave
		End Sub

		Private Sub tb_Enter(sender As Object, e As EventArgs)
			'...
		End Sub
		Private Sub tb_KeyDown(sender As Object, e As KeyEventArgs)
			'...
		End Sub
		Private Sub tb_Leave(sender As Object, e As EventArgs)
			'...
		End Sub
		Private Function DateTryParseSpecial(txt As String, ByRef result As Date) As Boolean
			If Date.TryParse(txt, result) Then Return True
			Dim chars = txt.ToCharArray
			Dim tag = "", monat = Date.Today.Month.ToString, jahr = Date.Today.Year.ToString
			Select Case txt.Length
				Case 1 : tag = {chars(0)}
				Case 2 : tag = {chars(0), chars(1)}
				Case 3 : tag = {chars(0), chars(1)} : monat = {chars(2)}
				Case 4, 6, 8
					tag = {chars(0), chars(1)} : monat = {chars(2), chars(3)}
					If txt.Length > 4 Then jahr = txt.Substring(4)
				Case Else : Return False
			End Select
			Return Date.TryParse($"{tag}.{monat}.{jahr}", result)
		End Function

#End Region' Textbox

#Region "DataGridView"
		<Extension()>
		Public Sub SetValue(col As DataGridViewColumn, rowIndex As Integer, value As Object)
			col.DataGridView(col.Index, rowIndex).Value = value
		End Sub
		''' <summary> returns null if invalid rowIndex </summary>
		<Extension()>
		Public Function DataRow(Of T As DataRow)(grd As DataGridView, rowIndex As Integer) As T
			If rowIndex < 0 Then Return Nothing
			Return grd.Rows(rowIndex).DataRow(Of T)()
		End Function
		<Extension()>
		Public Function DataRow(Of T As DataRow)(dgvRow As DataGridViewRow) As T
			Dim itm = DirectCast(dgvRow.DataBoundItem, DataRowView)
			Return If(itm.Null, Nothing, DirectCast(itm.Row, T))
		End Function
		''' <summary> returns null if invalid rowIndex </summary>
		<Extension()>
		Public Function DataRow(grd As DataGridView, rowIndex As Integer) As DataRow
			If rowIndex < 0 Then Return Nothing
			Dim itm = DirectCast(grd.Rows(rowIndex).DataBoundItem, DataRowView)
			Return If(itm.Null, Nothing, itm.Row)
		End Function

		<Extension()>
		Public Function IsColumnBound(grd As DataGridView, columnIndex As Integer, dataColumn As DataColumn) As Boolean
			If columnIndex < 0 Then Return False
			Return grd.Columns(columnIndex).DataPropertyName = dataColumn.ColumnName
		End Function
		<Extension()>
		Public Function Column(grd As DataGridView, dataColumn As DataColumn) As DataGridViewColumn
			Return grd.ColumnsX(dataColumn).First
		End Function
		<Extension()>
		Public Function ColumnsX(grd As DataGridView, dataColumn As DataColumn) As IEnumerable(Of DataGridViewColumn)
			Return grd.Columns.Cast(Of DataGridViewColumn).Where(Function(col) col.DataPropertyName = dataColumn.ColumnName)
		End Function
#End Region 'DataGridView

#Region "TabControl"
		''' <summary>
		''' Dieser Schwachsinn im Form_Load ausgeführt behebt einen Bug beim DataBinding auf beim Start nicht sichtbaren Tabpages.
		''' </summary>
		<Extension()>
		Public Sub InitBindability(tc As TabControl)
			Dim parent = tc.FindForm
			parent.SuspendLayout()
			For Each tp As TabPage In tc.TabPages
				tp.SuspendLayout()
				For Each ctl In tp.Controls.Cast(Of Control).ToArray
					parent.Controls.Add(ctl)
					tp.Controls.Add(ctl)
				Next
				tp.ResumeLayout()
			Next
			parent.ResumeLayout()
		End Sub

		''' <summary>hides Riders of TabControl</summary>
		<Extension()>
		Public Sub HideRiders(tc As TabControl)
			tc.SuspendLayout()
			tc.SizeMode = TabSizeMode.Fixed
			tc.ItemSize = New Size(0, 1)
			tc.Appearance = TabAppearance.Buttons
			tc.ResumeLayout()
		End Sub

		''' <summary>Setzt den Focus nachm Tab-Selectieren wieder zurück wo er herkam</summary>
		<Extension()>
		Public Sub ToFront(tp As TabPage)
			With DirectCast(tp.Parent, TabControl)
				If .SelectedTab Is tp Then Return
				Dim focused = .FindForm.ActiveControl
				.SelectedTab = tp
				If focused.NotNull Then BusyDelay.SetCallback(AddressOf focused.Focus)
			End With
		End Sub
#End Region 'TabControl

	End Module

End Namespace
